//+------------------------------------------------------------------+
//|                                            _Bid_To_File.mq4 |
//|                                          Copyright  2009, DRKNN |
//|                                                    drknn@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, DRKNN"
#property link      "drknn@mail.ru"

//----     
#property indicator_separate_window
//----   
#property indicator_buffers 1
//----   
#property indicator_color1 Blue
//---- buffers
double ExtMapBuffer1[];

// ----   --------
extern int MaxDeep=1000;//   

// ---   ----------
int      TickCounter=0;// 
int      myBars;
string   FileName,TextInFile;
int      FileHandl,fm;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit(){

  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
   
  // ---------    ------------
  FileName=Symbol()+"_"+DoubleToStr(Day(),0)+"_"+DoubleToStr(Month(),0)+"_"+DoubleToStr(Year(),0)+".txt";
  TextInFile=TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
  TextInFile=TextInFile+" "+DoubleToStr(Bid,Digits);
  if(isNewBar()==true){//  ,   
    TickCounter++;//     
    ExtMapBuffer1[0]=Bid;
    WritingLineInFile(FileName,TextInFile);
  }
  else{//        
    TickCounter++;//     
    ShiftArray();//     1
    ExtMapBuffer1[0]=Bid;
    WritingLineInFile(FileName,TextInFile);
  }
   
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

//--------   -----------------------------

/*
  ,       .        .
     ShiftArray()     -     1    . 
*/

// ---------------------- ShiftArray() -----------------------
//    
//--------------------------
void ShiftArray(){
  
  if(TickCounter>2*MaxDeep){//      2 ,    
    for(int i=TickCounter;i>=MaxDeep;i--){
      ExtMapBuffer1[i]=0.0;
    }
    TickCounter=MaxDeep;
  }
  
  for(int cnt=TickCounter;cnt>0;cnt--){//  
    ExtMapBuffer1[cnt]=ExtMapBuffer1[cnt-1];
  }
  
}
//------------------------------------------------------------

/*
       tickCounter,
        .
   ,         .
        :
*/
//+------------------------------------------------------------------+
//|  isNewBar() -                                                  |
//+------------------------------------------------------------------+
bool isNewBar(){
  bool res=false;
  if(myBars!=Bars){
    res=true;
    myBars=Bars;
  }   
//----
   return(res);
  }
//--------------------------------------------------------------- 

//+------------------------- WritingLineInFile() ----------------------------
//|     
//+---------------------------------
void WritingLineInFile(string FlName, string Text){
  int file_handle=FileOpen(FlName, FILE_CSV|FILE_READ|FILE_WRITE, " ");
	if (file_handle>0){
		FileSeek(file_handle,0,SEEK_END);
		FileWrite(file_handle,Text);
		FileClose(file_handle);
	}
	else{
	  Print(" ",GetLastError()," -     ",FlName);
   }
}
//--------------------------------------------------------------------------- 